Image (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional.image, class: Image

# Class Image

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.Task
org.apache.tools.ant.taskdefs.MatchingTask
org.apache.tools.ant.taskdefs.optional.image.Image

All Implemented Interfaces:
  `Cloneable, SelectorContainer`

@Deprecated public class Image extends MatchingTask
Deprecated.
JAI is not developed any more. Internal APIs that JAI depends on were scheduled for removal in Java 7 and finally removed in Java 9.
A MatchingTask which relies on JAI (Java Advanced Imaging) to perform image manipulation operations on existing images. The operations are represented as ImageOperation DataType objects. The operations are arranged to conform to the Chaining Model of JAI. Check out the JAI Programming Guide.

See Also:
  - `ImageOperation`
  - `DataType`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected File`
  `destDir`
  Deprecated.
  `protected Vector<FileSet>`
  `filesets`
  Deprecated.
  `protected boolean`
  `garbage_collect`
  Deprecated.
  `protected Vector<ImageOperation>`
  `instructions`
  Deprecated.
  `protected boolean`
  `overwrite`
  Deprecated.
  `protected File`
  `srcDir`
  Deprecated.
  `protected String`
  `str_encoding`
  Deprecated.

  ### Fields inherited from class MatchingTask

  `fileset`
  Modifier and Type
  Field
  Description
  `protected FileSet`
  `fileset`

  ### Fields inherited from class Task

  `target, taskName, taskType, wrapper`
  Modifier and Type
  Field
  Description
  `protected Target`
  `target`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskName`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskType`
  Deprecated.
  since 1.6.x.
  `protected RuntimeConfigurable`
  `wrapper`
  Deprecated.
  since 1.6.x.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Image()`
  Deprecated.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(ImageOperation instr)`
  Deprecated.
  Add an ImageOperation to chain.
  `void`
  `add(FileNameMapper fileNameMapper)`
  Deprecated.
  Add a nested filenamemapper.
  `void`
  `addDraw(Draw instr)`
  Deprecated.
  Add a Draw ImageOperation to the chain.
  `void`
  `addFileset(FileSet set)`
  Deprecated.
  Add a set of files to be deleted.
  `void`
  `addImageOperation(ImageOperation instr)`
  Deprecated.
  Add an ImageOperation to chain.
  `void`
  `addRotate(Rotate instr)`
  Deprecated.
  Add a Rotate ImageOperation to the chain.
  `void`
  `addScale(Scale instr)`
  Deprecated.
  Add a Scale ImageOperation to the chain.
  `Mapper`
  `createMapper()`
  Deprecated.
  Defines the mapper to map source to destination files.
  `void`
  `execute()`
  Deprecated.
  Executes the Task.
  `int`
  `processDir(File srcDir, String[] srcNames, File dstDir, FileNameMapper mapper)`
  Deprecated.
  Executes all the chained ImageOperations on the files inside the directory.
  `void`
  `processFile(File file)`
  Deprecated.
  this method isn't used anymore
  `void`
  `processFile(File file, File newFile)`
  Deprecated.
  Executes all the chained ImageOperations on the file specified.
  `void`
  `setDestDir(File destDir)`
  Deprecated.
  Set the destination directory for manipulated images.
  `void`
  `setEncoding(String encoding)`
  Deprecated.
  Set the image encoding type.
  `void`
  `setFailOnError(boolean failonerror)`
  Deprecated.
  Set whether to fail on error.
  `void`
  `setGc(boolean gc)`
  Deprecated.
  Set whether to invoke Garbage Collection after each image processed.
  `void`
  `setOverwrite(boolean overwrite)`
  Deprecated.
  Set whether to overwrite a file if there is a naming conflict.
  `void`
  `setSrcdir(File srcDir)`
  Deprecated.
  Set the source dir to find the image files.
  `protected void`
  `validateAttributes()`
  Deprecated.
  Ensure we have a consistent and legal set of attributes, and set any internal flags necessary based on different combinations of attributes.

  ### Methods inherited from class MatchingTask

  `add, addAnd, addContains, addContainsRegexp, addCustom, addDate, addDepend, addDepth, addDifferent, addFilename, addMajority, addModified, addNone, addNot, addOr, addPresent, addSelector, addSize, addType, appendSelector, createExclude, createExcludesFile, createInclude, createIncludesFile, createPatternSet, getDirectoryScanner, getImplicitFileSet, getSelectors, hasSelectors, selectorCount, selectorElements, setCaseSensitive, setDefaultexcludes, setExcludes, setExcludesfile, setFollowSymlinks, setIncludes, setIncludesfile, setProject, XsetIgnore, XsetItems`
  Modifier and Type
  Method
  Description
  `void`
  `add(FileSelector selector)`
  add an arbitrary selector
  `void`
  `addAnd(AndSelector selector)`
  add an "And" selector entry on the selector list
  `void`
  `addContains(ContainsSelector selector)`
  add a contains selector entry on the selector list
  `void`
  `addContainsRegexp(ContainsRegexpSelector selector)`
  add a regular expression selector entry on the selector list
  `void`
  `addCustom(ExtendSelector selector)`
  add an extended selector entry on the selector list
  `void`
  `addDate(DateSelector selector)`
  add a selector date entry on the selector list
  `void`
  `addDepend(DependSelector selector)`
  add a depends selector entry on the selector list
  `void`
  `addDepth(DepthSelector selector)`
  add a depth selector entry on the selector list
  `void`
  `addDifferent(DifferentSelector selector)`
  add a type selector entry on the type list
  `void`
  `addFilename(FilenameSelector selector)`
  add a selector filename entry on the selector list
  `void`
  `addMajority(MajoritySelector selector)`
  add a majority selector entry on the selector list
  `void`
  `addModified(ModifiedSelector selector)`
  add the modified selector
  `void`
  `addNone(NoneSelector selector)`
  add a "None" selector entry on the selector list
  `void`
  `addNot(NotSelector selector)`
  add a "Not" selector entry on the selector list
  `void`
  `addOr(OrSelector selector)`
  add an "Or" selector entry on the selector list
  `void`
  `addPresent(PresentSelector selector)`
  add a present selector entry on the selector list
  `void`
  `addSelector(SelectSelector selector)`
  add a "Select" selector entry on the selector list
  `void`
  `addSize(SizeSelector selector)`
  add a selector size entry on the selector list
  `void`
  `addType(TypeSelector selector)`
  add a type selector entry on the type list
  `void`
  `appendSelector(FileSelector selector)`
  Add a new selector into this container.
  `PatternSet.NameEntry`
  `createExclude()`
  add a name entry on the exclude list
  `PatternSet.NameEntry`
  `createExcludesFile()`
  add a name entry on the include files list
  `PatternSet.NameEntry`
  `createInclude()`
  add a name entry on the include list
  `PatternSet.NameEntry`
  `createIncludesFile()`
  add a name entry on the include files list
  `PatternSet`
  `createPatternSet()`
  add a set of patterns
  `protected DirectoryScanner`
  `getDirectoryScanner(File baseDir)`
  Returns the directory scanner needed to access the files to process.
  `protected final FileSet`
  `getImplicitFileSet()`
  Accessor for the implicit fileset.
  `FileSelector[]`
  `getSelectors(Project p)`
  Returns the set of selectors as an array.
  `boolean`
  `hasSelectors()`
  Indicates whether there are any selectors here.
  `int`
  `selectorCount()`
  Gives the count of the number of selectors in this container
  `Enumeration<FileSelector>`
  `selectorElements()`
  Returns an enumerator for accessing the set of selectors.
  `void`
  `setCaseSensitive(boolean isCaseSensitive)`
  Sets case sensitivity of the file system
  `void`
  `setDefaultexcludes(boolean useDefaultExcludes)`
  Sets whether default exclusions should be used or not.
  `void`
  `setExcludes(String excludes)`
  Sets the set of exclude patterns.
  `void`
  `setExcludesfile(File excludesfile)`
  Sets the name of the file containing the includes patterns.
  `void`
  `setFollowSymlinks(boolean followSymlinks)`
  Sets whether or not symbolic links or Windows junctions should be followed.
  `void`
  `setIncludes(String includes)`
  Sets the set of include patterns.
  `void`
  `setIncludesfile(File includesfile)`
  Sets the name of the file containing the includes patterns.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.
  `void`
  `XsetIgnore(String ignoreString)`
  List of filenames and directory names to not include.
  `void`
  `XsetItems(String itemString)`
  Set this to be the items in the base directory that you want to be included.

  ### Methods inherited from class Task

  `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`
  Modifier and Type
  Method
  Description
  `final void`
  `bindToOwner(Task owner)`
  Bind a task to another; use this when configuring a newly created task to do work on behalf of another.
  `Target`
  `getOwningTarget()`
  Returns the container target of this task.
  `RuntimeConfigurable`
  `getRuntimeConfigurableWrapper()`
  Returns the wrapper used for runtime configuration.
  `String`
  `getTaskName()`
  Returns the name to use in logging messages.
  `String`
  `getTaskType()`
  Return the type of task.
  `protected RuntimeConfigurable`
  `getWrapper()`
  Return the runtime configurable structure for this task.
  `protected void`
  `handleErrorFlush(String output)`
  Handles an error line by logging it with the WARN priority.
  `protected void`
  `handleErrorOutput(String output)`
  Handles an error output by logging it with the WARN priority.
  `protected void`
  `handleFlush(String output)`
  Handles output by logging it with the INFO priority.
  `protected int`
  `handleInput(byte[] buffer, int offset, int length)`
  Handle an input request by this task.
  `protected void`
  `handleOutput(String output)`
  Handles output by logging it with the INFO priority.
  `void`
  `init()`
  Called by the project to let the task initialize properly.
  `protected final boolean`
  `isInvalid()`
  Has this task been marked invalid?
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(String msg, Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `maybeConfigure()`
  Configures this task - if it hasn't been done already.
  `final void`
  `perform()`
  Performs this task if it's still valid, or gets a replacement version and performs that otherwise.
  `void`
  `reconfigure()`
  Force the task to be reconfigured from its RuntimeConfigurable.
  `void`
  `setOwningTarget(Target target)`
  Sets the target container of this task.
  `void`
  `setRuntimeConfigurableWrapper(RuntimeConfigurable wrapper)`
  Sets the wrapper to be used for runtime configuration.
  `void`
  `setTaskName(String name)`
  Sets the name to use in logging messages.
  `void`
  `setTaskType(String type)`
  Sets the name with which the task has been invoked.

  ### Methods inherited from class ProjectComponent

  `clone, getDescription, getLocation, getProject, setDescription, setLocation`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### instructions

    protected Vector<ImageOperation> instructions
    Deprecated.

  - ### overwrite

    protected boolean overwrite
    Deprecated.

  - ### filesets

    protected Vector<FileSet> filesets
    Deprecated.

  - ### srcDir

    protected File srcDir
    Deprecated.

  - ### destDir

    protected File destDir
    Deprecated.

  - ### str_encoding

    protected String str_encoding
    Deprecated.

  - ### garbage_collect

    protected boolean garbage_collect
    Deprecated.

- ## Constructor Details

  - ### Image

    public Image()
    Deprecated.

- ## Method Details

  - ### addFileset

    public void addFileset(FileSet set)
    Deprecated.
    Add a set of files to be deleted.
    Parameters:
      `set` - the FileSet to add.

  - ### setFailOnError

    public void setFailOnError(boolean failonerror)
    Deprecated.
    Set whether to fail on error. If false, note errors to the output but keep going.
    Parameters:
      `failonerror` - true or false.

  - ### setSrcdir

    public void setSrcdir(File srcDir)
    Deprecated.
    Set the source dir to find the image files.
    Parameters:
      `srcDir` - the directory in which the image files reside.

  - ### setEncoding

    public void setEncoding(String encoding)
    Deprecated.
    Set the image encoding type. See the encoding table in the JAI Programming Guide.
    Parameters:
      `encoding` - the String image encoding.

  - ### setOverwrite

    public void setOverwrite(boolean overwrite)
    Deprecated.
    Set whether to overwrite a file if there is a naming conflict.
    Parameters:
      `overwrite` - whether to overwrite.

  - ### setGc

    public void setGc(boolean gc)
    Deprecated.
    Set whether to invoke Garbage Collection after each image processed. Defaults to false.
    Parameters:
      `gc` - whether to invoke the garbage collector.

  - ### setDestDir

    public void setDestDir(File destDir)
    Deprecated.
    Set the destination directory for manipulated images.
    Parameters:
      `destDir` - The destination directory.

  - ### addImageOperation

    public void addImageOperation(ImageOperation instr)
    Deprecated.
    Add an ImageOperation to chain.
    Parameters:
      `instr` - The ImageOperation to append to the chain.

  - ### addRotate

    public void addRotate(Rotate instr)
    Deprecated.
    Add a Rotate ImageOperation to the chain.
    Parameters:
      `instr` - The Rotate operation to add to the chain.
    See Also:
      - `Rotate`

  - ### addScale

    public void addScale(Scale instr)
    Deprecated.
    Add a Scale ImageOperation to the chain.
    Parameters:
      `instr` - The Scale operation to add to the chain.
    See Also:
      - `Scale`

  - ### addDraw

    public void addDraw(Draw instr)
    Deprecated.
    Add a Draw ImageOperation to the chain. DrawOperation DataType objects can be nested inside the Draw object.
    Parameters:
      `instr` - The Draw operation to add to the chain.
    See Also:
      - `Draw`
      - `DrawOperation`

  - ### add

    public void add(ImageOperation instr)
    Deprecated.
    Add an ImageOperation to chain.
    Parameters:
      `instr` - The ImageOperation to append to the chain.
    Since:
      Ant 1.7

  - ### createMapper

    public Mapper createMapper() throws BuildException
    Deprecated.
    Defines the mapper to map source to destination files.
    Returns:
      a mapper to be configured
    Throws:
      `BuildException` - if more than one mapper is defined
    Since:
      Ant 1.8.0

  - ### add

    public void add(FileNameMapper fileNameMapper)
    Deprecated.
    Add a nested filenamemapper.
    Parameters:
      `fileNameMapper` - the mapper to add.
    Since:
      Ant 1.8.0

  - ### processDir

    public int processDir(File srcDir, String[] srcNames, File dstDir, FileNameMapper mapper)
    Deprecated.
    Executes all the chained ImageOperations on the files inside the directory.
    Parameters:
      `srcDir` - File
      `srcNames` - String[]
      `dstDir` - File
      `mapper` - FileNameMapper
    Returns:
      int
    Since:
      Ant 1.8.0

  - ### processFile

    @Deprecated public void processFile(File file)
    Deprecated.
    this method isn't used anymore
    Executes all the chained ImageOperations on the file specified.
    Parameters:
      `file` - The file to be processed.

  - ### processFile

    public void processFile(File file, File newFile)
    Deprecated.
    Executes all the chained ImageOperations on the file specified.
    Parameters:
      `file` - The file to be processed.
      `newFile` - The file to write to.
    Since:
      Ant 1.8.0

  - ### execute

    public void execute() throws BuildException
    Deprecated.
    Executes the Task.
    Overrides:
      `execute` in class `Task`
    Throws:
      `BuildException` - on error.

  - ### validateAttributes

    protected void validateAttributes() throws BuildException
    Deprecated.
    Ensure we have a consistent and legal set of attributes, and set any internal flags necessary based on different combinations of attributes.
    Throws:
      `BuildException` - on error.